import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*;
/**
 * Displays a message at the end of the game (if the player wins) 
 * to give the player feedback on their performance (based on their final score)
 * 
 * @author Priya, Alex, Venkata
 * @version 1.0
 */
public class endMessage  extends Actor
{
    private myWorld mworld;
    private static final Color textColor = new Color(255, 165, 0);
    Font font = new Font ("Serif", 1, 16);

    /**
     * addedToWorld - allows class to access world variables
     */

    public void addedToWorld(World world)
    {
        mworld = (myWorld) world;
    } // end addedToWorld
    
    /**
     * endMessage - class constructor
     */
    public endMessage()
    {
        GreenfootImage img = new GreenfootImage(300, 100);    
        img.setFont(font);
        img.setColor(textColor);
        setImage(img);  
        //score = mworld.getBackupScore();
    }

    /**
     * Act - do whatever the endMessage wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     * 
     * In this case, the method will check to see what the final score is, and display
     * a message in accordance to it
     */
    public void act() 
    {
        if (mworld.getBackupScore() <= 0)
        {
            GreenfootImage img = getImage();
            img.drawString("You can do better than that...", 0, 40);
        }
        if (mworld.getBackupScore() > 0 && mworld.getBackupScore() <= 15)
        {
            GreenfootImage img = getImage();
            img.drawString("You're on the right track - try again!", 0, 40);
        }
        if (mworld.getBackupScore() > 15 && mworld.getBackupScore() <= 43)
        {
            GreenfootImage img = getImage();
            img.drawString("Good job! Keep it up!", 0, 40);
        }
        if (mworld.getBackupScore() > 43 && mworld.getBackupScore() <= 65)
        {
            GreenfootImage img = getImage();
            img.drawString("Great job! You are good at this!", 0, 40);
        }
        if (mworld.getBackupScore() > 65 && mworld.getBackupScore() < 80)
        {
            GreenfootImage img = getImage();
            img.drawString("An almost perfect score! Great job!!", 0, 40);
        }
        if (mworld.getBackupScore() == 80)
        {
            GreenfootImage img = getImage();
            img.drawString("EXCELLENT! You got a PERFECT score!!!", 0, 40);
        }
    }   
}
