import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
/**
 * This class sets up level "0" of the game. Level 0 comes before all other levels
 * for the purpose of giving the introduction, and other pre-game information
 * 
 * @author Priya, Alex, Venkata
 * @version 1.0
 */
public class level0  extends levels
{
    private myWorld mworld;
    private GreenfootImage bg;
    private GreenfootImage bg2;
    private GreenfootImage bg3;
    private GreenfootImage bg4;
    private int x, x2;
    
    /**
     * level0 - class constructor
     */
    public level0()
    {
        bg = new GreenfootImage("marbles.jpg");
        bg2 = new GreenfootImage("instructions1.png");
        bg3 = new GreenfootImage("instructions2.png");
        bg4 = new GreenfootImage("story1.png");
    }
    
    /**
     * addedToWorld - allows class to access world variables
     * Also sets default background image immedately upon being added
     * to the world. There are three default backgrounds, each giving
     * the player different kinds of pre-game information
     */
    public void addedToWorld(World world)
    {
        mworld = (myWorld) world;
        if (mworld.level == 0)
        {
            mworld.setBackground(bg);
        }
        if (mworld.level == 98)
        {
            mworld.setBackground(bg2);
        } 
        if (mworld.level == 99)
        {
            mworld.setBackground(bg3);
        }
        if (mworld.level == 100)
        {
            mworld.setBackground(bg4);
        }
        getImage().setTransparency(0); // sets default image of this class invisible
    }
    
    /**
     * checkStatus - shows the desired pre-game images in a particular order, and then 
     * changes the entire level of the game in order to reload this class and show a
     * different image
     */
    private void checkStatus()
    {
        if (mworld.level == 0)
        {
            Greenfoot.delay(100);
            mworld.changeLvl(98);
        }
        if (mworld.level == 98)
        {
            Greenfoot.delay(50);
            if (Greenfoot.mouseClicked(mworld))
            {
                x = Greenfoot.getMouseInfo().getX();
                mworld.changeLvl(99);
            }
        }
        if (mworld.level == 99)
        {
            Greenfoot.delay(10);
            if (Greenfoot.mouseClicked(mworld)  && Greenfoot.getMouseInfo().getX() != x)
            {
                x2 = Greenfoot.getMouseInfo().getX();
                mworld.changeLvl(100);
            } 
        }
        if (mworld.level == 100)
        {
            Greenfoot.delay(10);
            if (Greenfoot.mouseClicked(mworld) && Greenfoot.getMouseInfo().getX() != x && Greenfoot.getMouseInfo().getX() != x2)
            {
                mworld.changeLvl(1);
            }
        }
    }
    
    /**
     * Act - do whatever the level0 wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        checkStatus();
    }    
}
