import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*;
/**
 * Displays the current level being played
 * 
 * @author Priya, Alex, Venkata
 * @version 1.0
 */
public class levelCounter  extends Actor
{
    private myWorld mworld;     
    int newLevel = 0;
    private String text;
    private int stringLength;
    Font font = new Font ("Serif", 1, 20);
    private static final Color textColor = new Color(255, 165, 0);
    
    /**
     * addedToWorld - allows class to access world variables
     */ 
    public void addedToWorld(World world)
    {
        mworld = (myWorld) world;
    } // end addedToWorld
    
    /**
     * Act - do whatever the levelCounter wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        updateImage();
    }
    
    /**
     * levelCounter - this is the constructor for this class
     */
    public levelCounter()
    {
        this("");
        //newLevel = mworld.level;
    }
    
    /**
     * levelCounter - this is the constructor for this class that takes a parameter
     * @param prefix - a String to display before the counter itself
     */
    // constructor w/ parameter
    public levelCounter (String prefix)
    {
        text = prefix;
        stringLength = (text.length() + 2) * 10;
        setImage(new GreenfootImage(stringLength, 16));
        GreenfootImage image = getImage();
        image.setColor(textColor);
        image.setFont(font);
        updateImage();
    }

    /**
     * updateImage - updates the display for each level
     */
    private void updateImage() 
    {   
        if (mworld.level == 1)
        {
            newLevel = 1;
        }
        if (mworld.level == 2)
        {
            newLevel = 2;
        }
        if (mworld.level == 3)
        {
            newLevel = 3;
        }
        if (mworld.level == 4)
        {
            newLevel = 4;
        }
        if (mworld.level == 5)
        {
            newLevel = 5;
        }
        
        GreenfootImage image = getImage();
        image.clear();
        image.drawString(text + " " + newLevel, 1, 15);
    } // end updateImage
}
