import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.lang.*;
/**
 * Contains all methods for the player to move
 * 
 * @author Priya, Alex, Venkata
 * @version 1.0
 */
public class player extends Mover
{
    private myWorld mworld;
    boolean pass = true;
    
    private GreenfootImage girlRight;
    private GreenfootImage girlLeft;
    private GreenfootImage subRight;
    private GreenfootImage subLeft;
    
    /**
     * addedToWorld - allows class to access world variables. 
     */
    public void addedToWorld(World world) 
    {
        mworld = (myWorld) world;  
        if (mworld.level == 4)
        {
            setImage(subRight);
        }
    } // end addedToWorld    
    
    /**
     * player - class constructor
     * Sets up appropriate images for when the player turns left or right
     */
    public player()
    {
        girlRight = new GreenfootImage("girl0.png");
        girlLeft = new GreenfootImage("girl4.png");
        subRight = new GreenfootImage("subRight.png"); 
        subLeft = new GreenfootImage("subLeft.png");
        
        // resets world variables
        mworld.correct = 0; 
        mworld.currentQuestion = 1;     
    }
    
    /**
     * Act - do whatever the player wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     * 
     * In this case, it checks to see which arrow key is pressed down, and moves
     * the character in the appropriate direction. 
     */
    public void act() throws IllegalStateException
    {
        
        checkObsticle();   
        try
        {
            if(Greenfoot.isKeyDown("right"))
            {
                if (canMove(1, 0))
                {
                    if (mworld.level != 4)
                    {
                        setImage(girlRight);
                    }
                    if (mworld.level == 4)
                    {
                        setImage(subRight);
                    }
                    setLocation(getX() + 1, getY());
                    mworld.setCoords(getX(),getY() );
                }
            }
            if(Greenfoot.isKeyDown("left"))
            {
                if (canMove(-1, 0))
                {
                    if (mworld.level != 4)
                    {
                        setImage(girlLeft);
                    }
                    if (mworld.level == 4)
                    {
                        setImage(subLeft);
                    }
                    setLocation(getX() - 1, getY());
                    mworld.setCoords(getX(),getY() );
                }
            }
            if(Greenfoot.isKeyDown("up"))
            {
                if (canMove(0, -1))
                {
                    setLocation(getX(), getY() - 1);
                    mworld.setCoords(getX(),getY() );
                }
            }
            if(Greenfoot.isKeyDown("down"))
            {
                if (canMove (0, 1))
                {
                    setLocation(getX(), getY() + 1); 
                    mworld.setCoords(getX(),getY() );
                }
            }
        }
        
        catch (Exception ISe)
        {
        }
    } // end act
    
    /**
     * canMove - Checks to see if player can move. Player cannot move through objects, 
     * or during an active question
     * 
     * @param x - x coordinate
     * @param y - y coordinate
     */
    public boolean canMove(int x, int y) throws IllegalStateException // do not remove!
    {
        Actor test;
        pass = true;
        try
        {
            // cannot move until puzzle is completed 
            if (mworld.puzzle == true)
            {
                pass = false;
            }
        
            // cannot move through an obsticle
            test = getOneObjectAtOffset(x, y, obsticles.class);
            if (test != null)
            {
                pass = false;
                mworld.puzzle = true;
            }     
        
            // cannot move through the wall
            test = getOneObjectAtOffset(x, y, paths.class);
            if (test != null)
            {
                pass = false;
            }
        }   
        
        catch (Exception ISe)
        {
        }
        return pass;
    } // end canMove
        
    /**
     * checkObsticle - if the player is in contact with an obstical, and picks the correct
     * answer to a question, the corresponding obstical will disappear, thus allowing the
     * player to continue forward (or advance to the next level)
     */
    private void checkObsticle()
    {
        if ( touches (waterPuddle.class) && mworld.correct == 1)
        {
            remove (waterPuddle.class);
        }
        if ( touches (rock.class) && mworld.correct == 1)
        {
            remove (rock.class);
        }
        if ( touches (tree.class) && mworld.correct == 1)
        {
            remove (tree.class);
        }        
        if ( touches (pufferfish.class) && mworld.correct == 1)
        {
            remove (pufferfish.class);
        }
        if ( touches (starfish.class) && mworld.correct == 1)
        {
            remove (starfish.class);
        }
        if ( touches (crab.class) && mworld.correct == 1)
        {
            remove (crab.class);
        }
        if ( touches (brokenbottle.class) && mworld.correct == 1)
        {
            remove (brokenbottle.class);
        }
        if ( touches (beachball.class) && mworld.correct == 1)
        {
            remove (beachball.class);
        }
        if ( touches (end.class) || touches (end2.class))
        {
            mworld.level += 1;
            mworld.setBackupScore(Score.score);
            mworld.changeLvl(mworld.level);
        }
    } // end checkObsticle
}
