import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*;
/**
 * Displays a visual countdown to zero from a specified starting time
 * 
 * @author Priya, Alex, Venkata
 * @version 1.0
 */
public class timer  extends Actor
{
    private myWorld mworld;  
    
    // variables for timer DISPLAY
    private int stringLength;
    private String text;
    Font font = new Font ("Serif", 1, 20);
    private static final Color textColor = new Color(255, 165, 0);
    
    // variables for timer MECHANISM
    int timer = 0;
    int theTime;
    int delay = 65;
    int target_time = 0;

    /**
     * addedToWorld - allows class to access world variables
     */
    public void addedToWorld(World world)
    {
        mworld = (myWorld) world;
        
        // reset variable
        timer = 0;
        // adjust countdown for each level
        if (mworld.level == 1)
        {
            theTime = 41;
        }
        if (mworld.level == 2)
        {
            theTime = 41;
        }
        if (mworld.level == 3)
        {
            theTime = 41;
        }
        if (mworld.level == 4)
        {
            theTime = 41;
        }
        if (mworld.level == 5)
        {
            theTime = 41;
        }
    } // end addedToWorld
    
    /**
     * Act - do whatever the timer wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        delay();
    }
    
    /**
     * timer - class constructor
     */
    public timer()
    {
        this("");
        //newLevel = mworld.level;
    }
    
    /**
     * timer - sets up the display for the timer
     * @param prefix - a String to be displayed before the timer itself
     */
    public timer (String prefix)
    {
        text = prefix;
        stringLength = (text.length() + 2) * 20;
        setImage(new GreenfootImage(stringLength, 16));
        GreenfootImage image = getImage();
        image.setColor(textColor);
        image.setFont(font);
        updateImage();
    }

    /**
     * delay - used to delay the change in numbers during the countdown to simulate actual
     * seconds, otherwise the numbers will change almost instantaneously
     */
    private void delay()
    {
        if (timer <= 0)
        {
            theTime--;
            timer = delay;

            if (theTime == target_time)
            {   
                // player loses
                mworld.changeLvl(97);
            }
            else
            {    
                timer--;
            }
            updateImage();
        }
        timer--;
    }
    
    /**
     * updateImage - updates the display on the timer with the next number
     */
    private void updateImage() 
    {   
        GreenfootImage image = getImage();
        image.clear();
        image.drawString(text + " " + theTime, 1, 15);
    } // end updateImage 
}